/* omrd.c Main entry point for omrd client program */
/* 
#---------------------------------------------------------------------+
#  Copyright (c) 2000 NRG Gladstone Operating Services.               |
#                All Rights Reserved.                                 |
#                                                                     |
#                                                                     |
#  This is free software; you can redistribute it and/or modify it    |
#  under the terms of the GNU General Public License as published by  |
#  the Free Software Foundation; either version 2 of the License, or  |
#  (at your option) any later version.                                |
#                                                                     |
#  This software is distributed in the hope that it will be useful,   |
#  but WITHOUT ANY WARRANTY; without even the implied warranty of     |
#  merchantability or fitness for a particular purpose. See the GNU   |
#  General Public License for more details.                           |
#                                                                     |
#  To obtain the GNU General Public License, write to:                |
#                                                                     |
#      Free Software Foundation, Inc.                                 |
#      59 Temple Place - Suite 330                                    |
#      Boston, MA  02111-1307                                         |
#      USA                                                            |
#---------------------------------------------------------------------+
*/

/*
# $Log: omrd.c,v $
# Revision 1.1  2000/03/19 22:30:17  dbond
# Initial revision
#
#
#
# 
*/


#include "omrd.h"

char omrd_v[] = "$Id: omrd.c,v 1.1 2000/03/19 22:30:17 dbond Exp $";
char omrd_x_v[] = OMRD_X;

int
myomwr_1( CLIENT* clnt,namenode *cbplist )
{
  int  *result_2;
  namenode  *nl;
  int ret;

  result_2 = omwr_1(cbplist, clnt);
  if (result_2 == NULL) {
    clnt_perror(clnt, "call failed:");
  }
  ret = *result_2;
/*  printf("result %d\n",*result_2); */
  xdr_free((xdrproc_t)xdr_int,(char *)result_2);
  return(ret);
}

/* Function to call the RPC for reading data from fox system */

int 
myomrd_1( CLIENT *clnt,namenode *cbplist ) {

  omrd_res  *result_1;
  namenode *nl;

  result_1 = omrd_1(cbplist, clnt);
  if (result_1 == NULL) {
    clnt_perror(clnt, "call failed:");
    return(1);
  }
  for(nl = result_1->omrd_res_u.list; nl != NULL;nl = nl->pNext){
    printf("%s  %s\n",nl->name,nl->value);
  }
  xdr_free((xdrproc_t)xdr_omrd_res,(char *)result_1);
  return(0);
}



main( int argc, char* argv[] )
{
  CLIENT *clnt;
  char *host,c;
  namelist nl,*nlp;
  namenode *cbplist;
  extern char *optarg;
  FILE *file;
  char cbp[MAXNAMLEN];
  char val[MAXNAMLEN];
  char comment[MAXNAMLEN];
  char buffer[80];
  int err;
  char *cmd;
  int count,error;
  /* find which command started the program */
  cmd=(char *)strdup(argv[0]+(strlen(argv[0])-4));


  if (argc < 2) {
    help_str(cmd);
    exit(1);
  }
  nlp = &cbplist; /* set the start address of the list */
  /* test for file or stdin */
  c=getopt(argc-1,&argv[1],"f:"); /* do some crap to fool sun parser */

  

  if (c != EOF) {
    /* file read */
    
    if (! strcmp(optarg,"-")) {
      file = stdin; /* read cbp list from stdin */
    } else { 
      file = fopen(optarg,"r");
      if (file == NULL){
	fprintf(stderr,"file does not exist\n");
	exit(1);
      }
    }
    /* read file and parse into linked list */
    while (fgets(buffer,80,file)) {

      if(!parse(buffer,cbp,val,comment)){
	nl = *nlp = (namenode *)malloc(sizeof(namenode));
	nl->name = (char *)strdup(cbp);
	nl->value = (char *)strdup(val);

	val[0]= '\0';
	nlp = &nl->pNext;
      }
    }
  } else { 
    /* all on the command line */
    /* Build namenode list for sending to server */
    if (!strcmp(cmd,"omrd")){
      if (argc < 3) {
	help_str(cmd);
	exit(1);
      }
      for (count = 2; count < argc ;count++){
	nl = *nlp = (namenode *)malloc(sizeof(namenode));
	nl->name = argv[count];
	nl->value = (char *)strdup("");
	nlp = &nl->pNext;
      }
    }
    if (!strcmp(cmd,"omwr")){
      if (argc < 4) {
	help_str(cmd);
	exit(1);
      }
      for (count = 2; count < argc ;count++){
/*	printf("arg %s\n",argv[count]); */
	nl = *nlp = (namenode *)malloc(sizeof(namenode));
	nl->name = (char *)strdup(argv[count]);
	if (argv[count][0] != '+') {
	  if (++count == argc) break;
	}
	nl->value = (char *)strdup(argv[count]);
	nlp = &nl->pNext;
      }
    }
  }
  *nlp = NULL;
  host = argv[1];
  clnt = clnt_create(host, OMPROG, OMVERS, "udp");
  if (clnt == NULL) {
    clnt_pcreateerror(host);
    exit(1);
  }
  if (!strcmp(cmd,"omrd")){
    error=myomrd_1( clnt,cbplist );
  }
  if (!strcmp(cmd,"omwr")){
    error=myomwr_1( clnt,cbplist );
  }
  for(nl = *nlp ; nl != NULL;nl = nl->pNext){
    free(nl);
  }
  clnt_destroy( clnt ); 
  free(cmd);
  exit(error);
}

int help_str(char *invoke) {
  if (!strcmp(invoke,"omrd")){ 
    /* invoked as omrd */
    printf("usage: %s host cbp cbp cbp cbp etc\nor omrd host -f <filename>\nor omrd host -f - (for stdin)\n",invoke);
    printf("file format C:B.P whitespace or line delimited\n");
  }
  if (!strcmp(invoke,"omwr")){ 
    /* invoked as omwr */
    printf("usage: omwr host [datatype] cbp value cbp value cbp valueetc\nor omwr host -f <filename>\nor omwr host -f - (for stdin)\n");
    printf("file format datatype C:B.P value whitespace or line delimited\ndatatypes may be used anywhere\nwithin the file to change to a new type\ntypes are +INT +FLOAT +STRING +BOOL +OM_BOOL +PKD_BOOL +PKD_LONG\n");
    
  }
}    

int parse(str,name,value,comment)
char *str, *name, *value,*comment;
{
  int pos;
  char *ch;


  if((strlen(str) < 2)) return(1); /* blank line */
  if(str[0] == '#') return(1); /* comment line */
  for(pos=0;str[pos] != '\0' ;pos++)
    {
      str[pos]=toupper(str[pos]);
      if(str[pos]=='\n') str[pos] = '\0';
    }
  sscanf(str,"%s %s",name,value);


/*   name[pos++]='\0'; */
  if(ch=(char *)strstr(str,"#"))
     strcpy(comment,ch+1);
  else strcpy(comment," ");

/*  printf("str %s name %s value %s comment %s\n",str,name,value,comment); */
  return(0);
}
                 
